Attribute VB_Name = "Module1"
Option Explicit

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function VarPtrArray Lib "msvbvm50.dll" Alias "VarPtr" (Ptr() As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)
Private Declare Function GetActiveWindow Lib "user32" () As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GdiFlush Lib "gdi32" () As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FrameRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function CreateDCAsNull Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, lpDeviceName As Any, lpOutput As Any, lpInitData As Any) As Long
Private Declare Function UpdateWindow Lib "user32" (ByVal hwnd As Long) As Long

Private Type MEMORYSTATUS
   dwLength As Long
   dwMemoryLoad As Long
   dwTotalPhys As Long
   dwAvailPhys As Long
   dwTotalPageFile As Long
   dwAvailPageFile As Long
   dwTotalVirtual As Long
   dwAvailVirtual As Long
End Type

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Private Type SAFEARRAYBOUND
    cElements As Long
    lLbound As Long
End Type

Private Type SAFEARRAY2D
    cDims As Integer
    fFeatures As Integer
    cbElements As Long
    cLocks As Long
    pvData As Long
    Bounds(0 To 1) As SAFEARRAYBOUND
End Type

Private Const Pi = 3.14159265359
Private Const SRCCOPY = &HCC0020

Private Sx As Long, Sy As Long
Private Dx As Long, Dy As Long
Private A As Single
Private Res As Single
Private theta As Single
Private Degrees As Long
Private p1x As Long, p1y As Long
Private p2x As Long, p2y As Long
Private n As Long
Private BkR As Byte, BkG As Byte, BkB As Byte
Private SrcR As Byte, SrcG As Byte, SrcB As Byte
Private Bcolor As Long
Private Y_array() As Integer
Private Bit_array() As Integer
Private Sh_array() As Byte
Private ImgX As Long, ImgY As Long
Private ImgT As Long, ImgB As Long, ImgL As Long, ImgR As Long
Private OldT As Long, OldB As Long, OldL As Long, OldR As Long
Private CurH As Long, CurW As Long
Private VSpace As Long, HSpace As Long
Private DestW As Long, DestH As Long
Private DestDC As Long, DestBMP As Long, DestDst As Long
Private ScreenCapBMP As Long, ScreenCapDst As Long, ScreenCapDC As Long
Private SourceH As Long, SourceW As Long
Private SourceDC As Long, SourceBMP As Long, SourceDst As Long
Private Start As Long
Private PosX(3) As Integer, PosY(3) As Integer
Private SinT As Single, CosT As Single
Private x As Long, y As Long
Private LimitX As Long
Private ctr As Byte
Private ScreenDC As Long
Private SH As Byte, SW As Byte

Private pictD() As Byte, pictS() As Byte
Private Dst_array As SAFEARRAY2D
Private Src_array As SAFEARRAY2D
Private bmDest As BITMAP, bmSource As BITMAP

Public PicDC As Long, PicDib As Long, PicDst As Long
Public ShDistH As Integer, ShDistW As Integer, ShColor As Byte
Public LoadedOK As Boolean

Public Sub DoTheDeed(FName As String, ByVal Turns As Byte, ByVal Delay As Byte, ByVal Rotation As Long, Transparent As Boolean, Shadow As Boolean, FadeImage As Boolean)

'Establish initial Position of Image, whose rotation center should be the middle of Form1. ImgX and ImgY are the center of rotation
Dim ThisWindow As Long, RC As RECT
ThisWindow = GetActiveWindow()
GetWindowRect ThisWindow, RC
ImgX = RC.Left + (RC.Right - RC.Left) / 2
ImgY = RC.Top + (RC.Bottom - RC.Top) / 2
DeleteObject ThisWindow

Form1.Visible = False

If Shadow = False Then ShDistH = 0: ShDistW = 0 Else ShDistH = -ShDistH

'Un-comment these lines if you are throwing out Form1. Then replace FName with xxx.bmp or xxx.jpg etc.
'If InStr(FName, ".bmp") > 0 Then LoadBitmap FName
'If InStr(FName, ".jpg") > 0 Then LoadJPG FName
'If LoadedOK = False Then MsgBox "Sorry, can't load the picture. Program aborted.", vbCritical, "Real Time Rotation": GoTo ExitNow

Dim PicBm As BITMAP
'Get BitMap dimensions of loaded .BMP or .JPG file into PicDib. See Module2.
GetObjectAPI PicDib, Len(PicBm), PicBm

If Transparent = True Or Shadow = True Then
    'Get color of Top Left pixel (i.e. backcolor)
    Bcolor = GetPixel(PicDC, 0&, 0&)
    'Separate Long Color Values into RGB
    BkR = CByte(Bcolor And &HFF&)
    BkG = CByte((Bcolor And &HFF00&) / &H100&)
    BkB = CByte((Bcolor And &HFF0000) / &H10000)
    'Bind the image in the smallest box that will fit. In other words, "crop" the image to mimimise memory requirement.
    'Start reading the Picture's backcolor pixels, starting at the Bottom, going up
    For y = PicBm.bmHeight - 1 To 1 Step -1
    For x = 0 To PicBm.bmWidth - 1
    'If pixel is not same color as backcolor (i.e. found the image), then exit
    If Bcolor <> GetPixel(PicDC, x, y) Then ImgB = y + 1: GoTo CONTINUE_T
    Next
    Next
    'Continue reading Pixels, starting at the top, going down
CONTINUE_T:
    For y = 0 To PicBm.bmHeight - 1
    For x = 0 To PicBm.bmWidth - 1
    If Bcolor <> GetPixel(PicDC, x, y) Then ImgT = y - 1: GoTo CONTINUE_L
    Next
    Next
    'And now find the width of the actual image. Left to right
CONTINUE_L:
    For x = 0 To PicBm.bmWidth - 1
    For y = 0 To PicBm.bmHeight - 1
    If Bcolor <> GetPixel(PicDC, x, y) Then ImgL = x - 1: GoTo CONTINUE_R
    Next
    Next
    'Measure from right to left.
CONTINUE_R:
    For x = PicBm.bmWidth - 1 To 1 Step -1
    For y = 0 To PicBm.bmHeight - 1
    If Bcolor <> GetPixel(PicDC, x, y) Then ImgR = x + 1: GoTo CONTINUE_END
    Next
    Next
CONTINUE_END:
    'Actual cropped image Width, Height.
    SourceW = ImgR - ImgL
    SourceH = ImgB - ImgT
    'and, just in case...
    If SourceW > PicBm.bmWidth Then SourceW = PicBm.bmWidth: ImgL = 0
    If SourceH > PicBm.bmHeight Then SourceH = PicBm.bmHeight: ImgT = 0
Else
    SourceW = PicBm.bmWidth
    SourceH = PicBm.bmHeight
End If

'Create Memory DC for Source
SourceDC = CreateCompatibleDC(PicDC)
SourceBMP = CreateCompatibleBitmap(PicDC, SourceW, SourceH)
SourceDst = SelectObject(SourceDC, SourceBMP)
'Copy original image (now cropped) to Source
BitBlt SourceDC, 0&, 0&, SourceW, SourceH, PicDC, ImgL, ImgT, SRCCOPY

'Delete original image Dib or Bitmap. No longer needed, free memory.
PicDib = SelectObject(PicDC, PicDst)
DeleteObject PicDib
DeleteDC PicDC

'Source, get bitmap info
GetObjectAPI SourceBMP, Len(bmSource), bmSource
'Have the Source matrix point to bitmap pixels
With Src_array
    .cbElements = 1
    .cDims = 2
    .Bounds(0).lLbound = 0
    .Bounds(0).cElements = bmSource.bmHeight
    .Bounds(1).lLbound = 0
    .Bounds(1).cElements = bmSource.bmWidthBytes
    .pvData = bmSource.bmBits
End With
CopyMemory ByVal VarPtrArray(pictS), VarPtr(Src_array), 4

'Establish radius of rotation
n = CLng(Sqr(1& * SourceH * SourceH + 1& * SourceW * SourceW) \ 2)

'Establish center of rotation for Source. Round Up by 1 pixel
Dim Num As Single, RoundNum As Integer
'Width. Round Up
RoundNum = SourceW / 2
Num = RoundNum / 2
Sx = Int(Num)
If Num <> Sx Then Sx = RoundNum + 0.5 Else Sx = RoundNum
'Height, Round Up
RoundNum = SourceH / 2
Num = RoundNum / 2
Sy = Int(Num)
If Num <> Sy Then Sy = RoundNum + 0.5 Else Sy = RoundNum

If Transparent = True Or Shadow = True Then
    'Find the maximum Height of p2Y for p2X=0 that holds "non-transparent" pixels.
    'Why bother? Because a circle needs half the area of a cube to rotate in, where the circle's diameter is equal
    'to the square's height (or width). Therefore the number of calculations are halved i.e. speed increased by x 2.
    'The effectiveness of this technique depends on the shape of the image. Circles best, squares worst.
    Dim Max As Long
    For Degrees = 0 To 360          'In 1 Degree increments
    CosT = Cos(Pi / 2 + (2 * Pi * Degrees) / 360)
    SinT = Sin(Pi / 2 + (2 * Pi * Degrees) / 360)
        'Loop through all the image's pixels. Compare Red, Green and Blue. Search from the top-down
        For p2y = n To 0 Step -1    'Loop starting from the Top
            p1x = p2y * CosT
            p1y = p2y * SinT
            'Top Right segment
            If Sy >= -p1y And Sx >= -p1x And Sy + p1y < SourceH And Sx + p1x < SourceW Then
                If pictS((Sx + p1x) * 3, Sy + p1y) <> BkR And _
                pictS((Sx + p1x) * 3 + 1, Sy + p1y) <> BkG And _
                pictS((Sx + p1x) * 3 + 2, Sy + p1y) <> BkB Then
                    If p2y > Max Then Max = p2y
                p2y = 0                         'Found non-transparent pixel, exit Loop
                End If
            End If
        Next
    Next
    If Max > n Or Max = 0 Then Max = n
    n = Max
End If

'No shadow? Set Shadow Distance (Horiz and Vertical) to zero
If Shadow = False Then ShDistW = 0: ShDistH = 0

'Establish dimensions for Destination, DestDC. Increase number by two pixels to take into account rounding errors.
DestW = 2 * n + 2
DestH = DestW

'Establish center of rotation for Destination
Dx = CLng(DestW \ 2) - 1
Dy = Dx

'Create Memory DC for Destination, DestDC. Increase dimensions by Shadow distance (if any)
DestDC = CreateCompatibleDC(SourceDC)
DestBMP = CreateCompatibleBitmap(SourceDC, DestW + Abs(ShDistW), DestH + Abs(ShDistH))
DestDst = SelectObject(DestDC, DestBMP)
'Destination, get bitmap info
GetObjectAPI DestBMP, Len(bmDest), bmDest

'Have the Destination matrix point to bitmap pixels
With Dst_array
    .cbElements = 1
    .cDims = 2
    .Bounds(0).lLbound = 0
    .Bounds(0).cElements = bmDest.bmHeight
    .Bounds(1).lLbound = 0
    .Bounds(1).cElements = bmDest.bmWidthBytes
    .pvData = bmDest.bmBits
End With
CopyMemory ByVal VarPtrArray(pictD), VarPtr(Dst_array), 4

'Work only "inside" the rotating circle (i.e. don't deal with the "edges" between the image forming a circle
'as it rotates and the destination rectangle). Saves about 15% time.
Dim MinSqr As Long, TmpX As Long, TmpY As Long
ReDim Y_array(n)
MinSqr = n * n
For TmpX = 0 To n
    RoundNum = Sqr(MinSqr - TmpX * TmpX)
    Num = RoundNum / 2
    TmpY = Int(Num)
        If Num <> TmpY Then
        Y_array(TmpX) = CInt(RoundNum + 0.5) + 1
        Else
        Y_array(TmpX) = CInt(RoundNum) + 1
        End If
    If Y_array(TmpX) > n Then Y_array(TmpX) = n
Next

'Calculate rotation formula once, to speed-up display. Save in Bit_array
ReDim Bit_array(n, n)
For TmpX = 0 To n
    For TmpY = 0 To n
    Bit_array(TmpX, TmpY) = CInt(Sqr(TmpX * TmpX + TmpY * TmpY))
    Next
Next

'Create Shadow by reducing background's RGB values by ShColor. Save conversion in Sh_array
If Shadow = True Then
    ReDim Sh_array(255)
    For Max = 0 To 255
    If Max - ShColor <= 0 Then Sh_array(Max) = 0 Else Sh_array(Max) = Max - ShColor
    Next
End If

n = n - 1

'Delay a little for screen to catch-up with progie, just in case
GdiFlush
UpdateWindow ScreenDC
'Get the Desktop DC, so you can write to the Screen
ScreenDC = CreateDCAsNull("DISPLAY", ByVal 0&, ByVal 0&, ByVal 0&)

'Create temporary workbox to hold copy of Screen
ScreenCapDC = CreateCompatibleDC(DestDC)
ScreenCapBMP = CreateCompatibleBitmap(DestDC, DestW + Abs(ShDistW), DestH + Abs(ShDistH))
ScreenCapDst = SelectObject(ScreenCapDC, ScreenCapBMP)
'Copy Screen Background to ScreenCap.
BitBlt ScreenCapDC, 0&, 0&, DestW + Abs(ShDistW), DestH + Abs(ShDistH), ScreenDC, ImgX - Dx, ImgY - Dy, SRCCOPY

'Determine if system has free memory available. Available memory depends on size of bitmap or JPG and what other apps
'are currently loaded. If there is no free memory available, progie slows down dramatically. Better ask user.
Dim ms As MEMORYSTATUS
ms.dwLength = Len(ms)
GlobalMemoryStatus ms
'MsgBox "Avail Phys Memory= " + (Format$(ms.dwAvailPhys \ 1024, "###,###,###")) + "k"
If ms.dwAvailPhys <= 1024 Then
Dim Response
Response = MsgBox("The image you selected is too large and you have little free available" + Chr(13) + "memory left. The progie should run fine, but rotation will be very, very slow." + Chr(13) + "Would you like to Continue?", vbYesNo + vbQuestion, "Real Time Rotation")
If Response = vbNo Then GoTo TidyUp
End If

'Apply timer (time the app)
'Start = GetTickCount()

Dim i As Long
For i = 0 To ((Turns * 360) / Abs(Rotation))
Degrees = (i * Rotation)
If Abs(Degrees) > 360 Then Degrees = Degrees - 360 * (Degrees \ 360)
'Delay Factor
If Delay > 0 Then Sleep Delay
If Shadow = True Then RotateShadow                                            'Rotate Transparent + Shadow
If Transparent = True And Shadow = False Then RotateTrans       'Rotate Transparent, no Shadow
If Transparent = False And Shadow = False Then RotateSolid       'Rotate non-Transparent, no Shadow
Next

'Read Result, time elapsed
'MsgBox Str$(GetTickCount() - Start)

'Erase Screen, no gimmicks
If FadeImage = False Then
'Clean-Up Screen when rotations are finished
BitBlt ScreenDC, ImgX - Dx, ImgY - Dy, DestW + Abs(ShDistW), DestH + Abs(ShDistH), ScreenCapDC, 0&, 0&, SRCCOPY
'Tidy Up
GoTo TidyUp
End If

'Prepare Fade array.
Dim Fade_array() As Byte
Dim WNextBlk As Integer, HNextBlk As Integer
Dim Counter As Integer
Dim HBlock As Integer, WBlock As Integer
Dim WSectSize As Integer, HSectSize As Integer

'If Picture too large, speed up the process, use larger fade blocks
If DestW > 250 Then WBlock = Int((DestW + Abs(ShDistW)) \ 2) Else WBlock = DestW + Abs(ShDistW)
If DestH > 250 Then HBlock = Int((DestH + Abs(ShDistH)) \ 2) Else HBlock = DestH + Abs(ShDistH)
'Set the size of each width section
WSectSize = (DestW + Abs(ShDistW)) \ WBlock
'Set the size of each height section
HSectSize = (DestH + Abs(ShDistH)) \ HBlock
'Size array
ReDim Fade_array(WBlock, HBlock)

'Start Block array looping
Do
    Do
    WNextBlk = WBlock * Rnd 'Generate the random numbers
    HNextBlk = HBlock * Rnd 'Generate the random numbers
    If Fade_array(WNextBlk, HNextBlk) = 0 Then Exit Do
    Counter = Counter + 1
    If Counter = WBlock * 10 Or Counter = HBlock * 10 Then Exit Do
    Loop
        If Counter = WBlock * 10 Or Counter = HBlock * 10 Then Exit Do
        Counter = 0
        'Update the Fade_array
        Fade_array(WNextBlk, HNextBlk) = 1
       'Copy blocks from ScreenCap to Screen
        BitBlt ScreenDC, ImgX - Dx + WNextBlk * WSectSize, ImgY - Dy + HNextBlk * HSectSize, WSectSize, HSectSize, ScreenCapDC, WNextBlk * WSectSize, HNextBlk * HSectSize, SRCCOPY
Loop
'Clean-up image, one final time, just in case
BitBlt ScreenDC, ImgX - Dx, ImgY - Dy, DestW + Abs(ShDistW), DestH + Abs(ShDistH), ScreenCapDC, 0&, 0&, SRCCOPY
Erase Fade_array

'Tidy Up
TidyUp:
DeleteDC ScreenDC
DestBMP = SelectObject(DestDC, DestDst)
DeleteObject DestBMP
DeleteDC DestDC
SourceBMP = SelectObject(SourceDC, SourceDst)
DeleteObject SourceBMP
DeleteDC SourceDC
ScreenCapBMP = SelectObject(ScreenCapDC, ScreenCapDst)
DeleteObject ScreenCapBMP
DeleteDC ScreenCapDC
Erase Y_array
Erase Bit_array
Erase Sh_array

' Clear the temporary array descriptor
CopyMemory ByVal VarPtrArray(pictD), 0&, 4
CopyMemory ByVal VarPtrArray(pictS), 0&, 4

ExitNow:
Exit Sub

End Sub

'Rotate, non-Transparent
Private Function RotateSolid()

'Find extreme dimensions (x,y for each corner) of object as it rotates
theta = (2 * Pi * Degrees) / 360 'convert Degrees to Radians
SinT = Sin(theta)
CosT = Cos(theta)
PosX(0) = -Sx * CosT - Sy * SinT
PosY(0) = -Sy * CosT + Sx * SinT
PosX(1) = (SourceW - Sx) * CosT - Sy * SinT
PosY(1) = -Sy * CosT - (SourceW - Sx) * SinT
PosX(2) = (SourceW - Sx) * CosT + (SourceH - Sy) * SinT
PosY(2) = (SourceH - Sy) * CosT - (SourceW - Sx) * SinT
PosX(3) = -Sx * CosT + (SourceH - Sy) * SinT
PosY(3) = (SourceH - Sy) * CosT + Sx * SinT

'Find extreme dimensions of the object to make bounding rectangle for it
ImgL = n * 3: ImgR = 0
ImgT = n * 3: ImgB = 0
For ctr = 0 To 3
If PosX(ctr) < ImgL Then ImgL = PosX(ctr)        'Left
If PosX(ctr) > ImgR Then ImgR = PosX(ctr)       'Right
If PosY(ctr) < ImgT Then ImgT = PosY(ctr)       'Top
If PosY(ctr) > ImgB Then ImgB = PosY(ctr)       'Bottom
Next

'Min Width
If (ImgR - ImgL) < (OldR - OldL) Then CurW = OldR - OldL Else CurW = ImgR - ImgL
'Min Height
If (ImgB - ImgT) < (OldB - OldT) Then CurH = OldB - OldT Else CurH = ImgB - ImgT

'Left and Top Spacer for bounding rectangle (i.e. difference between min. width and min. height and DestDC width and height)
HSpace = (DestW - CurW) \ 2
VSpace = (DestH - CurH) \ 2

'Copy screen background to working DC
BitBlt DestDC, HSpace, VSpace, CurW, CurH, ScreenCapDC, HSpace, VSpace, SRCCOPY

'Minimal bounding box (DestDC) dimensions. Set LimitX within this minimum. (Have already set Y previously)
If SourceW > SourceH Then
Select Case Abs(Degrees)
Case 45 To 135, 225 To 315
LimitX = (ImgB - ImgT) \ 2
Case Else
LimitX = (ImgR - ImgL) \ 2
End Select
Else
Select Case Abs(Degrees)
Case 45 To 135, 225 To 315
LimitX = (ImgR - ImgL) \ 2
Case Else
LimitX = (ImgB - ImgT) \ 2
End Select
End If
If LimitX > n Then LimitX = n

'Rotate Image
For p2x = 0 To LimitX
For p2y = 0 To Y_array(p2x)

If p2x = 0 Then A = Pi / 2 Else A = Atn(p2y / p2x)
Res = Bit_array(p2x, p2y)
p1x = Res * Cos(A + theta!)
p1y = Res * Sin(A + theta!)

'Top Left
'Ensure array reads pixels that are within the Source image. Otherwise "CopyMemory" generates error and progie blows-out.
If Sx - p1y >= 0 And Sy + p1x < SourceH And Sy + p1x >= 0 And Sx - p1y < SourceW Then
'Then copy the RGB value of each Source pixel to Destination. 1 byte per source pixel R, G and B color values.
pictD((Dx - p2y) * 3, Dy + p2x) = pictS((Sx - p1y) * 3, Sy + p1x)
pictD((Dx - p2y) * 3 + 1, Dy + p2x) = pictS((Sx - p1y) * 3 + 1, Sy + p1x)
pictD((Dx - p2y) * 3 + 2, Dy + p2x) = pictS((Sx - p1y) * 3 + 2, Sy + p1x)
End If

'Top Right
If Sy >= -p1y And Sx >= -p1x And Sy + p1y < SourceH And Sx + p1x < SourceW Then
pictD((Dx + p2x) * 3, Dy + p2y) = pictS((Sx + p1x) * 3, Sy + p1y)
pictD((Dx + p2x) * 3 + 1, Dy + p2y) = pictS((Sx + p1x) * 3 + 1, Sy + p1y)
pictD((Dx + p2x) * 3 + 2, Dy + p2y) = pictS((Sx + p1x) * 3 + 2, Sy + p1y)
End If

'Bottom right
If Sy >= p1x And Sx >= -p1y And Sx + p1y < SourceW And Sy - p1x < SourceH Then
pictD((Dx + p2y) * 3, Dy - p2x) = pictS((Sx + p1y) * 3, Sy - p1x)
pictD((Dx + p2y) * 3 + 1, Dy - p2x) = pictS((Sx + p1y) * 3 + 1, Sy - p1x)
pictD((Dx + p2y) * 3 + 2, Dy - p2x) = pictS((Sx + p1y) * 3 + 2, Sy - p1x)
End If

'Bottom Left
If Sy >= p1y And Sx >= p1x And Sy - p1y < SourceH And Sx - p1x < SourceW Then
pictD((Dx - p2x) * 3, Dy - p2y) = pictS((Sx - p1x) * 3, Sy - p1y)
pictD((Dx - p2x) * 3 + 1, Dy - p2y) = pictS((Sx - p1x) * 3 + 1, Sy - p1y)
pictD((Dx - p2x) * 3 + 2, Dy - p2y) = pictS((Sx - p1x) * 3 + 2, Sy - p1y)
End If

Next
Next

'Copy image to Screen
BitBlt ScreenDC, ImgX - Dx + HSpace, ImgY - Dy + VSpace, CurW, CurH, DestDC, HSpace, VSpace, SRCCOPY

'Update values. Increment by 3 pixels to take into account pixel trails
OldT = ImgT - 3
OldB = ImgB + 3
OldL = ImgL - 3
OldR = ImgR + 3

End Function

'Rotate, Transparent and with Shadow
Private Function RotateShadow()

'We need to render twice. Otherwise certain parts of the Shadow over-write the Image and the end result is a mess.
'So, we render the Shadow first, then the Image on top of the Shadow and copy the combined picture to Screen.
'It follows that the process is much slower than rotating in Transparent or Solid mode.

'Find rotated object extreme dimensions (x,y for each corner)
theta = (2 * Pi * Degrees) / 360
SinT = Sin(theta)
CosT = Cos(theta)
PosX(0) = -Sx * CosT - Sy * SinT
PosY(0) = -Sy * CosT + Sx * SinT
PosX(1) = (SourceW - Sx) * CosT - Sy * SinT
PosY(1) = -Sy * CosT - (SourceW - Sx) * SinT
PosX(2) = (SourceW - Sx) * CosT + (SourceH - Sy) * SinT
PosY(2) = (SourceH - Sy) * CosT - (SourceW - Sx) * SinT
PosX(3) = -Sx * CosT + (SourceH - Sy) * SinT
PosY(3) = (SourceH - Sy) * CosT + Sx * SinT

'Find minimum bounding rectangle dimensions
ImgL = n * 3: ImgR = 0
ImgT = n * 3: ImgB = 0
For ctr = 0 To 3
If PosX(ctr) < ImgL Then ImgL = PosX(ctr)
If PosX(ctr) > ImgR Then ImgR = PosX(ctr)
If PosY(ctr) < ImgT Then ImgT = PosY(ctr)
If PosY(ctr) > ImgB Then ImgB = PosY(ctr)
Next

'Compensate for Shadow
ImgR = ImgR + Abs(ShDistW)
ImgB = ImgB + Abs(ShDistH)
If ShDistW > 0 Then SW = ShDistW Else SW = 0
If ShDistH > 0 Then SH = ShDistH Else SH = 0

'Min Height
If (ImgB - ImgT) < (OldB - OldT) Then CurH = OldB - OldT Else CurH = ImgB - ImgT
'Min Width
If (ImgR - ImgL) < (OldR - OldL) Then CurW = OldR - OldL Else CurW = ImgR - ImgL

'Spacer for bounding rectangle
HSpace = (DestW - CurW + Abs(ShDistW)) \ 2
VSpace = (DestH - CurH + Abs(ShDistH)) \ 2

If SourceW > SourceH Then
Select Case Abs(Degrees)
Case 45 To 135, 225 To 315
LimitX = (ImgB - ImgT) \ 2
Case Else
LimitX = (ImgR - ImgL) \ 2
End Select
Else
Select Case Abs(Degrees)
Case 45 To 135, 225 To 315
LimitX = (ImgR - ImgL) \ 2
Case Else
LimitX = (ImgB - ImgT) \ 2
End Select
End If
If LimitX > n Then LimitX = n

'Copy screen background to working DC
BitBlt DestDC, HSpace, VSpace, CurW, CurH, ScreenCapDC, HSpace, VSpace, SRCCOPY

'Shadow
For p2x = 0 To LimitX
For p2y = 1 To Y_array(p2x)

If p2x = 0 Then A = Pi / 2 Else A = Atn(p2y / p2x)
Res = Bit_array(p2x, p2y)
p1x = Res * Cos(A + theta!)
p1y = Res * Sin(A + theta!)

'Top Left
If Sx - p1y >= 0 And Sy + p1x < SourceH And Sy + p1x >= 0 And Sx - p1y < SourceW Then
If BkR <> pictS((Sx - p1y) * 3, Sy + p1x) And _
BkG <> pictS((Sx - p1y) * 3 + 1, Sy + p1x) And _
BkB <> pictS((Sx - p1y) * 3 + 2, Sy + p1x) Then
x = (Dx - p2y + SW) * 3
y = Dy + p2x + SH
'Reads each Source pixel color value and determines if it is a transparent or non-transparent pixel. If transparent, decrements
'it by a predetermined amount (ShValue) that is already pre-calculated in Sh_array. It then changes the value of the target
'pixel accordingly in Destination. Three RGB values (Red, Green, Blue), need to be read, compared and changed each time.
pictD(x, y) = Sh_array(pictD(x, y))
pictD(x + 1, y) = Sh_array(pictD(x + 1, y))
pictD(x + 2, y) = Sh_array(pictD(x + 2, y))
End If
End If

'Top Right
If Sy >= -p1y And Sx >= -p1x And Sy + p1y < SourceH And Sx + p1x < SourceW Then
If BkR <> pictS((Sx + p1x) * 3, Sy + p1y) And _
BkG <> pictS((Sx + p1x) * 3 + 1, Sy + p1y) And _
BkB <> pictS((Sx + p1x) * 3 + 2, Sy + p1y) Then
x = (Dx + p2x + SW) * 3
y = Dy + p2y + SH
pictD(x, y) = Sh_array(pictD(x, y))
pictD(x + 1, y) = Sh_array(pictD(x + 1, y))
pictD(x + 2, y) = Sh_array(pictD(x + 2, y))
End If
End If

'Bottom Right
If Sy >= p1x And Sx >= -p1y And Sx + p1y < SourceW And Sy - p1x < SourceH Then
If BkR <> pictS((Sx + p1y) * 3, Sy - p1x) And _
BkG <> pictS((Sx + p1y) * 3 + 1, Sy - p1x) And _
BkB <> pictS((Sx + p1y) * 3 + 2, Sy - p1x) Then
x = (Dx + p2y + SW) * 3
y = Dy - p2x + SH
pictD(x, y) = Sh_array(pictD(x, y))
pictD(x + 1, y) = Sh_array(pictD(x + 1, y))
pictD(x + 2, y) = Sh_array(pictD(x + 2, y))
End If
End If

'Bottom Left
If Sy >= p1y And Sx >= p1x And Sy - p1y < SourceH And Sx - p1x < SourceW Then
If BkR <> pictS((Sx - p1x) * 3, Sy - p1y) And _
BkG <> pictS((Sx - p1x) * 3 + 1, Sy - p1y) And _
BkB <> pictS((Sx - p1x) * 3 + 2, Sy - p1y) Then
x = (Dx - p2x + SW) * 3
y = Dy - p2y + SH
pictD(x, y) = Sh_array(pictD(x, y))
pictD(x + 1, y) = Sh_array(pictD(x + 1, y))
pictD(x + 2, y) = Sh_array(pictD(x + 2, y))
End If
End If

Next
Next

'Image
'First, compensate for Shadow
If ShDistW >= 0 Then SW = 0 Else SW = Abs(ShDistW)
If ShDistH >= 0 Then SH = 0 Else SH = Abs(ShDistH)

For p2x = 0 To LimitX
For p2y = 0 To Y_array(p2x)

If p2x = 0 Then A = Pi / 2 Else A = Atn(p2y / p2x)
Res = Bit_array(p2x, p2y)
p1x = Res * Cos(A + theta!)
p1y = Res * Sin(A + theta!)

'Top Left
If Sx - p1y >= 0 And Sy + p1x < SourceH And Sy + p1x >= 0 And Sx - p1y < SourceW Then
SrcR = pictS((Sx - p1y) * 3, Sy + p1x)
SrcG = pictS((Sx - p1y) * 3 + 1, Sy + p1x)
SrcB = pictS((Sx - p1y) * 3 + 2, Sy + p1x)
    If SrcR <> BkR And SrcG <> BkG And SrcB <> BkB Then
    x = (Dx - p2y + SW) * 3
    y = Dy + p2x + SH
    pictD(x, y) = SrcR
    pictD(x + 1, y) = SrcG
    pictD(x + 2, y) = SrcB
    End If
End If

'Top Right
If Sy >= -p1y And Sx >= -p1x And Sy + p1y < SourceH And Sx + p1x < SourceW Then
SrcR = pictS((Sx + p1x) * 3, Sy + p1y)
SrcG = pictS((Sx + p1x) * 3 + 1, Sy + p1y)
SrcB = pictS((Sx + p1x) * 3 + 2, Sy + p1y)
    If SrcR <> BkR And SrcG <> BkG And SrcB <> BkB Then
    x = (Dx + p2x + SW) * 3
    y = Dy + p2y + SH
    pictD(x, y) = SrcR
    pictD(x + 1, y) = SrcG
    pictD(x + 2, y) = SrcB
    End If
End If

'Bottom Right
If Sy >= p1x And Sx >= -p1y And Sx + p1y < SourceW And Sy - p1x < SourceH Then
SrcR = pictS((Sx + p1y) * 3, Sy - p1x)
SrcG = pictS((Sx + p1y) * 3 + 1, Sy - p1x)
SrcB = pictS((Sx + p1y) * 3 + 2, Sy - p1x)
    If SrcR <> BkR And SrcG <> BkG And SrcB <> BkB Then
    x = (Dx + p2y + SW) * 3
    y = Dy - p2x + SH
    pictD(x, y) = SrcR
    pictD(x + 1, y) = SrcG
    pictD(x + 2, y) = SrcB
    End If
End If

'Bottom Left
If Sy >= p1y And Sx >= p1x And Sy - p1y < SourceH And Sx - p1x < SourceW Then
SrcR = pictS((Sx - p1x) * 3, Sy - p1y)
SrcG = pictS((Sx - p1x) * 3 + 1, Sy - p1y)
SrcB = pictS((Sx - p1x) * 3 + 2, Sy - p1y)
    If SrcR <> BkR And SrcG <> BkG And SrcB <> BkB Then
    x = (Dx - p2x + SW) * 3
    y = Dy - p2y + SH
    pictD(x, y) = SrcR
    pictD(x + 1, y) = SrcG
    pictD(x + 2, y) = SrcB
    End If
End If

Next
Next

'Copy combined image to Screen
BitBlt ScreenDC, ImgX - Dx + HSpace, ImgY - Dy + VSpace, CurW, CurH, DestDC, HSpace, VSpace, SRCCOPY

'Update values
OldT = ImgT - 3
OldB = ImgB + 3
OldL = ImgL - 3
OldR = ImgR + 3

End Function

'Rotate, Transparent
Private Function RotateTrans()

'Find rotated object extreme dimensions (x,y for each corner)
theta = (2 * Pi * Degrees) / 360
SinT = Sin(theta)
CosT = Cos(theta)
PosX(0) = -Sx * CosT - Sy * SinT
PosY(0) = -Sy * CosT + Sx * SinT
PosX(1) = (SourceW - Sx) * CosT - Sy * SinT
PosY(1) = -Sy * CosT - (SourceW - Sx) * SinT
PosX(2) = (SourceW - Sx) * CosT + (SourceH - Sy) * SinT
PosY(2) = (SourceH - Sy) * CosT - (SourceW - Sx) * SinT
PosX(3) = -Sx * CosT + (SourceH - Sy) * SinT
PosY(3) = (SourceH - Sy) * CosT + Sx * SinT

'Find minimum bounding rectangle dimensions
ImgL = n * 3: ImgR = 0
ImgT = n * 3: ImgB = 0
For ctr = 0 To 3
If PosX(ctr) < ImgL Then ImgL = PosX(ctr)
If PosX(ctr) > ImgR Then ImgR = PosX(ctr)
If PosY(ctr) < ImgT Then ImgT = PosY(ctr)
If PosY(ctr) > ImgB Then ImgB = PosY(ctr)
Next

If SourceW > SourceH Then
Select Case Abs(Degrees)
Case 45 To 135, 225 To 315
LimitX = (ImgB - ImgT) \ 2
Case Else
LimitX = (ImgR - ImgL) \ 2
End Select
Else
Select Case Abs(Degrees)
Case 45 To 135, 225 To 315
LimitX = (ImgR - ImgL) \ 2
Case Else
LimitX = (ImgB - ImgT) \ 2
End Select
End If
If LimitX > n Then LimitX = n

'Min Height
If (ImgB - ImgT) < (OldB - OldT) Then CurH = OldB - OldT Else CurH = ImgB - ImgT
'Min Width
If (ImgR - ImgL) < (OldR - OldL) Then CurW = OldR - OldL Else CurW = ImgR - ImgL

'Spacer for bounding rectangle
HSpace = (DestW - CurW) \ 2
VSpace = (DestH - CurH) \ 2

'Un-comment the following if you want to see how the bounding rectangle works.
'Dim hBrush As Long
'Dim RC As RECT
'hBrush = CreateSolidBrush(vbRed)
'RC.Left = ImgX - Dx + HSpace
'RC.Top = ImgY - Dy + VSpace
'RC.Right = RC.Left + CurW
'RC.Bottom = RC.Top + CurH
'FrameRect ScreenDC, RC, hBrush
'DeleteObject hBrush

'Copy screen background to working DC
BitBlt DestDC, HSpace, VSpace, CurW, CurH, ScreenCapDC, HSpace, VSpace, SRCCOPY

'Solid part of Image, minimum values
For p2x = 0 To LimitX
For p2y = 0 To Y_array(p2x)

If p2x = 0 Then A = Pi / 2 Else A = Atn(p2y / p2x)
Res = Bit_array(p2x, p2y)
p1x = Res * Cos(A + theta!)
p1y = Res * Sin(A + theta!)

'Top Left
If Sx - p1y >= 0 And Sy + p1x < SourceH And Sy + p1x >= 0 And Sx - p1y < SourceW Then
SrcR = pictS((Sx - p1y) * 3, Sy + p1x)
SrcG = pictS((Sx - p1y) * 3 + 1, Sy + p1x)
SrcB = pictS((Sx - p1y) * 3 + 2, Sy + p1x)
    If SrcR <> BkR And SrcG <> BkG And SrcB <> BkB Then
    pictD((Dx - p2y) * 3, Dy + p2x) = SrcR
    pictD((Dx - p2y) * 3 + 1, Dy + p2x) = SrcG
    pictD((Dx - p2y) * 3 + 2, Dy + p2x) = SrcB
    End If
End If

'Top Right
If Sy >= -p1y And Sx >= -p1x And Sy + p1y < SourceH And Sx + p1x < SourceW Then
SrcR = pictS((Sx + p1x) * 3, Sy + p1y)
SrcG = pictS((Sx + p1x) * 3 + 1, Sy + p1y)
SrcB = pictS((Sx + p1x) * 3 + 2, Sy + p1y)
    If SrcR <> BkR And SrcG <> BkG And SrcB <> BkB Then
    pictD((Dx + p2x) * 3, Dy + p2y) = SrcR
    pictD((Dx + p2x) * 3 + 1, Dy + p2y) = SrcG
    pictD((Dx + p2x) * 3 + 2, Dy + p2y) = SrcB
    End If
End If

'Bottom Right
If Sy >= p1x And Sx >= -p1y And Sx + p1y < SourceW And Sy - p1x < SourceH Then
SrcR = pictS((Sx + p1y) * 3, Sy - p1x)
SrcG = pictS((Sx + p1y) * 3 + 1, Sy - p1x)
SrcB = pictS((Sx + p1y) * 3 + 2, Sy - p1x)
    If SrcR <> BkR And SrcG <> BkG And SrcB <> BkB Then
    pictD((Dx + p2y) * 3, Dy - p2x) = SrcR
    pictD((Dx + p2y) * 3 + 1, Dy - p2x) = SrcG
    pictD((Dx + p2y) * 3 + 2, Dy - p2x) = SrcB
    End If
End If

'Bottom Left
If Sy >= p1y And Sx >= p1x And Sy - p1y < SourceH And Sx - p1x < SourceW Then
SrcR = pictS((Sx - p1x) * 3, Sy - p1y)
SrcG = pictS((Sx - p1x) * 3 + 1, Sy - p1y)
SrcB = pictS((Sx - p1x) * 3 + 2, Sy - p1y)
    If SrcR <> BkR And SrcG <> BkG And SrcB <> BkB Then
    pictD((Dx - p2x) * 3, Dy - p2y) = SrcR
    pictD((Dx - p2x) * 3 + 1, Dy - p2y) = SrcG
    pictD((Dx - p2x) * 3 + 2, Dy - p2y) = SrcB
    End If
End If

Next
Next

'Copy image to Screen
BitBlt ScreenDC, ImgX - Dx + HSpace, ImgY - Dy + VSpace, CurW, CurH, DestDC, HSpace, VSpace, SRCCOPY

'Update values
OldT = ImgT - 3
OldB = ImgB + 3
OldL = ImgL - 3
OldR = ImgR + 3

End Function



